/* Demonstrate casting syntax, as well as the
   oddity that the byte type automatically wraps around
   when the value is out of range.
   Such wrapping is typical of a clock, but not a speedometer or thermometer.
*/
class CastDemo
{
  public static void main(String[] args)
  {
    double x, y, myDouble;
    byte b;
    int i;
    char ch;

    x = 10.0;
    y = 3.0;

    myDouble = (x / y); // cast double to int
    System.out.println("Integer outcome of x / y: " + myDouble);

    i = (int) (x / y); // cast double to int
    System.out.println("Integer outcome of x / y: " + i);

    System.out.println("The constant value of Byte.MAX_VALUE is " + Byte.MAX_VALUE);

    i = 100;
    b = (byte) i;
    System.out.println("Value of b: " + b);

    i = 128;
    b = (byte) i;
    System.out.println("Value of b when cast as a byte that corresponds to 128: " + b);

    i = 255;
    b = (byte) i;
    System.out.println("Value of b when cast as a byte that corresponds to 255: " + b);

    i = 256;
    b = (byte) i;
    System.out.println("Value of b when cast as a byte that corresponds to 256: " + b);
    System.out.println("Value of i: " + i);

    i = 257;
    b = (byte) i;
    System.out.println("Value of b when cast as a byte that corresponds to 257: " + b);

    i = 129;
    b = (byte) i;
    System.out.println("Value of b when cast as a byte that corresponds to 129: " + b);

    b = 88; // ASCII code for X
    ch = (char) b;
    System.out.println("ch: " + ch);
  }
}